Program FiBu;

{
 ķ
  -*> Fire Bubbles V1.0 <*-  
 ķ
  Copyright(C) 1996-Forever - BitMaster. All rights are left out.           
  This is a little demo/tutorial about fading routines and TMT Pascal.      
  I hope you'll find this useful/nice!                                      
  Various constants can be changed to various degrees to customize this     
  source. Last 14th Feb I turned the old BP version of this demo with very  
  little effort into a burning "Valentine" with various screens and hearts  
  flying all around the screen... I put it in the autoexec of the computers 
  in my school's labz and it provided me with many "appreciations" by the   
  girl who saw it! 8D                                                       
                                                                            
  NOTES:                                                                    
  -BIAS could be easily removed by fine tuning the palette                  
  -I hate commenting source code... I think this time I've really done a    
   miracle! 8D                                                              
  -The font can be easily obtained from the system, but it would not be the 
   same on every 'puter...                                                  
  -My english is still in beta version... 8D                                
  -The bubble is not that perfect... try adjusting the values!              
  -I would appreciate comments, bug reports, suggestions or anything else!  
                                                                            
  ThiZ dEMo wAz bRoUgHt 2 YoU by:   BitMaster   AKA   Johnny Piacentini     
                                    E-Mail: johnny@mediacom.it              
                                                                            
 Ľ
}

{$r-,q-,i-}

Type
     BubType =
               Record
                     BPos : Longint;
                     Dest : Longint;
                     InkX : Longint;
                     InkY : Longint;
               end;

     FontType = Array[0..255,1..8] of Byte;

Const
      Bubby : Array[1..25] of Byte = (  0,140,160,140,  0,
                                      140,150,177,150,140,
                                      160,177,200,177,160,
                                      140,150,177,150,140,
                                        0,140,160,140,  0);

      STEPS      = 50;  -- The number of STEPS for the moving process.
      DELTA_X    = 3;   -- The horizontal distance between adjacent bubbles.
      DELTA_Y    = 4;   -- The vertical distance between adjacent bubbles.
      SPACING    = 2;   -- The distance between the characters.
      TEXT_      = 'TMT Pascal';
                        -- This is the text string presented on screen.
                        -- Can be freely customized...
      MAX_BUBS   = 500; -- Max number of bubbles. If your text requires
                        -- more than 500 increase it.

Var i,StepC,BubC  : Word;
    Bubs          : Array[1..MAX_BUBS] of BubType;
    f             : File;
    fnt           : FontType;
    VS1,VS2       : Array[0..15999] of DWord;

{ ########################################################################### }

Function Sar(n : Longint; c : Byte) : Longint; Assembler;

{ Shifts right a signed nuber. It goes like this:

  +-+-+-+-+-+-+-+-+
  |1|0|1|1|0|1|1|1| Real nuber
  +-+-+-+-+-+-+-+-+
  |0|1|0|1|1|0|1|1| SHRed(1) number
  +-+-+-+-+-+-+-+-+
  |1|0|0|1|1|0|1|1| SARed(1) number
  +-+-+-+-+-+-+-+-+

  SAL is equivalent to SHL }

Asm
        Push  CX
        Mov   EAX,[n]
        Mov   CL,[c]
        SAR   EAX,CL
        Pop   CX
end;

{ ########################################################################### }

Procedure VSync; Assembler;

{ This procedure waits for a vertical retrace.
  When the electronic beam of your monitor gets to the bottom of the screen
  it has to come up again. During this operation(technically referred as
  "vertical retrace") no drawing is performed and you can write freely
  to the video memory for 1.25ms without the boring flicker. }

Asm
   Mov DX,03DAh

@Retrace1:
   In  AL,DX       { First we have to wait for the current retrace }
   And AL,8        { to end, so that we don't start writing at the }
   JNZ @Retrace1   { end of an already started one... }

@Retrace2:
   In  AL,DX       { ...then we have to wait for a new one to start. }
   And AL,8
   JZ  @Retrace2
end;

{ ########################################################################### }

Procedure SetRGB(c,r,g,b : Byte );

{ Set color "c" of the palette to the value specified by the "r"ed, "g"reen"
  and "b"lue components. }

Begin
  Port[$3C8] := c;
  Port[$3C9] := r;
  Port[$3C9] := g;
  Port[$3C9] := b;
end;

{ ########################################################################### }

Procedure PutBub(Loc : Word); Assembler;

{ This procedure puts a bubble at offset "Loc" in video memory }

Asm
   Push   ECX
   Mov    ESI,Offset [Bubby]
   Mov    EDI,Offset [VS1]
   Add    EDI,[Loc]
   Mov    CL,5
   @@Lupp:
    LodSD
    Mov    CH,4
    @@Luppp:
     Cmp    AL,0
     JE     @@Dontwrite
      Mov    [EDI],AL
     @@Dontwrite:
     Inc    EDI
     Shr    EAX,8
     Dec    CH
    JNZ    @@Luppp
    LodSB
    Cmp    AL,0
    JE     @@Dontwrite2
     Mov    [EDI],AL
    @@Dontwrite2:
    Add    EDI,316
    Dec    CL
   JNZ    @@Lupp
   Pop    ECX
end;

{ ########################################################################### }

Procedure SetBubs(x,y : Word;s : String); { Set up bubs position according to the given string }

{
 This procedure calculates the offset in video memory of the given (x,y)
 coordinates and performs a scan of the given string: the 8x8 font of
 each char is read and a bub is associated with every bit set to 1.
 The bub position(.BPos) is randomly choosen, the destination(.Dest) is set
 to the current offset(calculated from the starting one using the constants
 defined at the top of the program) and the x and y increment(.InkX,.InkY) are calculated
 using the two previous values.
}

Var i,b,n : Byte;
    p     : Word;
    c     : Array[1..8] of Byte;

Begin
  p:= (y*320)+x;
  For i:= 1 to Byte(s[0]) do
  Begin
    c:= fnt[Byte(s[i])];
    For n:= 1 to 8 do
    Begin
      For b:= 7 downto 0 do
      Begin
        If (c[n] and (1 shl b))<>0 then
        Begin
          Inc(BubC);
          If BubC > MAX_BUBS then
          Begin
               Writeln(#10#10#13,'Your text string more bubbles than the current maximum!',#10#10#13);
               HALT(1);
          end;
          Bubs[BubC].BPos:= Random(64000-(320*10));
          If Bubs[BubC].BPos mod 320 > 310 then Dec(Bubs[BubC].BPos,10);
          Bubs[BubC].Dest:= p;
          Bubs[BubC].InkX:= (((p mod 320) - (Bubs[BubC].BPos mod 320)) shl 10) div STEPS;
          Bubs[BubC].InkY:= (((p div 320) - (Bubs[BubC].BPos div 320)) shl 10) div STEPS;
        end; { If (c[n]... }
        p:= p+DELTA_X;
      end; { For b }
      p:= p+(DELTA_Y*320)-(DELTA_X*8);
    end; { For n }
    p:= p+SPACING-((DELTA_Y*320)*8)+(DELTA_X*8);
  end; { For i }
end;

{ ########################################################################### }

Begin
    { - File I/O -

     The external file Font.fnt contains an 8x8 font used by SetBubs }

     Assign(f,'Fibu.Fnt');
     Reset(f,SizeOf(FontType));
     If IOResult<>0 then
     Begin
        Write('FIBU.FNT not in current directory!');
        HALT(2);
     end;
     BlockRead(f,fnt,1);
     Close(f);

     { - Global variables set up - }

     Randomize;
     BubC:= 0;  -- Indexes the last active bubble
     StepC:= 0; -- Keeps track of the current step

     { - Mixed stuff - }

     SetBubs(23,84,TEXT_); { Sets an adequate number of bubbles to compose
                            the given string. Have a look at the procedure }

     For i:= 0 to 15999 do VS1[i]:= 0; -- Clear VS1
     For i:= 0 to 15999 do VS2[i]:= 0; -- Clear VS2

     { - Set mode 13h - Graphics 320x200x256 - }
     Asm
        Mov   AX,13h
        Int   10h
     end;

     { - VGA palette setup loop - }
     For i := 1 to 64 do
     Begin
          SetRGB(i    , (i*2-1) shr 1, 0            , 0            );
          SetRGB(i+64 , 63           , (i*2-1) shr 1, 0            );
          SetRGB(i+128, 63           , 63           , (i*2-1) shr 1);
          SetRGB(i+192, 63           , 63           , 63           );
     end;
     SetRGB(0,0,0,0);

     { - Main routine - }

     Repeat
       { While StepC<STEPS the bubbles are plot using an offset from the
         starting position, calculated as an increment multiplied by the
         current step.
         When the last step is reached the bubs are plot directly to their
         final position(specified by the .Dest field in the record)
         because the increment is not very accurate and the string would
         appear slightly inaccurate. }

       If StepC<STEPS then
       Begin
         For i:= 1 to BubC do PutBub(Bubs[i].BPos+
                                        Sar(Bubs[i].InkX*StepC,10)+
                                        Sar(Bubs[i].InkY*StepC,10)*320);
            Inc(StepC);
       end
       else For i:= 1 to BubC do PutBub(Bubs[i].Dest);

{ We are going to "fade" the fire bubbles from VS1 to VS2.
  The fade process goes like this:

   VIDEO MEMORY ASCII DRAWING(TM) 8D

   +-+-+-+-       +-+-+-+-
   |1|2|3|        | | | |
   +-+-+-+-       +-+-+-+-   X:= (((1+2+3+4+5+6+7+8) div 8) + O) div 2
   |4|O|5|  ====> | |X| |
   +-+-+-+-       +-+-+-+-   Excluding the external ones(which obviously
   |6|7|8|        | | | |    can't be faded) we must do this for every
   +-+-+-+-       +-+-+-+-   pixel in VS1...
   | | | |        | | | |

   In my routine I read 4 bytez at one time, so I've decided to process
   two pixels in each loop to optimize the reads: EBX will keep track of
   the two different sums.
   Look at the following scheme to understand what's going on:

   VS1:           VS2:

   +-+-+-+-+-     +-+-+-+-+-  X = ( ( (A+B+C+E+G+I+J+K) div 8 ) + F ) div 2
   |A|B|C|D|      | | | | |   Y = ( ( (B+C+D+F+H+J+K+L) div 8 ) + G ) div 2
   +-+-+-+-+-     +-+-+-+-+-
   |E|F|G|H|      | |X|Y| |
   +-+-+-+-+-     +-+-+-+-+-
   |I|J|K|L|      | | | | |
   +-+-+-+-+-     +-+-+-+-+-
   | | | | |      | | | | |

In the comments I'll use exactly these identifiers to explain what I'm
doing. The syntax of the comments will be as follows:

   EAX [ A . 0 | / . 0 ]

EAX is the register mnemonic. The brackets show its contents:
-The "|" divides the most significant word from the least significant one.
-The "." divides the most significant byte from the least one of each word.
-The "/" specifies an unknown or unuseful value
-The "0" specifies a 0 value. Note that "/" and "0" are VERY different...
-The "A" refers to the identifier found in the scheme. It could have been
 B,C,X or any other...

!IMPORTANT!: When a LodSD is performed, you'll notice that the bytes are
             read in a sort of reverse order... to understand why this
             happens, note that the registers have their most significant
             byte on the left, which is exactly the opposite as the memory
             scheme we drew.
}
       Asm
          Push  EDX         { TMT exepcts these regs to be preserved }
          Push  ECX
          Push  EBX

          Mov   ESI,Offset [VS1] { ESI points to "A" }

          Mov   EDI,Offset [VS2]
          Add   EDI,321          { EDI points to "X" }

          Mov   CX,198           { CX contains the nuber of row to process.
                                   The screen is made up of 200 rows, but
                                   we must exclude the first and the last
                                   'coz we know they can't be faded. }

     @@YLoop:
          Rol   ECX,16           { We push the number of rows in the high }
          Mov   CX,318/2         { word and put in the low one the number
                                   of columns/2. We must divide by 2 'coz
                                   we process two pixel in each loop }

     @@XLoop:
          LodSD                   {  EAX [ D . C | B . A ]  }
          Ror   EAX,8             {  EAX [ A . D | C . B ]  }
          Mov   BH,AL             {  EBX [ / . / | B . / ]  }
          Shr   AX,8              {  EAX [ A . D | 0 . C ]  }
          Shr   BX,8              {  EBX [ / . / | 0 . B ]  }
          Add   BX,AX             {  EBX [ / . / |  B+C  ]  }
          Mov   AX,BX             {  EAX [ A . D |  B+C  ]  }
          Shl   EBX,16            {  EBX [  B+C  | 0 . 0 ]  }
          Mov   BX,AX             {  EBX [  B+C  |  B+C  ]  }
          Shr   EAX,8             {  EAX [ 0 . A | D . / ]  }
          Shr   AX,8              {  EAX [ 0 . A | 0 . D ]  }
          Add   BX,AX             {  EBX [  B+C  | B+C+D ]  }
          Rol   EBX,16            {  EBX [ B+C+D |  B+C  ]  }
          Shr   EAX,16            {  EAX [ 0 . 0 | 0 . A ]  }
          Add   BX,AX             {  EBX [ B+C+D | A+B+C ]  }
                                  {  V = B+C+D / W = A+B+C  }
                                  {  EBX [   V   |   W   ]  }

          Add   ESI,316
          LodSD                   {  EAX [ H . G | F . E ]  }
          Mov   EDX,EAX           {  EDX [ H . G | F . E ]  }
          And   EAX,0FF00FFh      {  EAX [ 0 . G | 0 . E ]  }
          Add   BX,AX             {  EBX [   V   |  W+E  ]  }
          Shr   EAX,16            {  EAX [ 0 . 0 | 0 . G ]  }
          Add   BX,AX             {  EBX [   V   | W+E+G ]  }
          Rol   EBX,16            {  EBX [ W+E+G |   V   ]  }
          Mov   EAX,EDX           {  EAX [ H . G | F . E ]  }
          Shr   EAX,8             {  EAX [ 0 . H | G . F ]  }
          Xor   AH,AH             {  EAX [ 0 . H | 0 . F ]  }
          Add   BX,AX             {  EBX [ W+E+G |  V+F  ]  }
          Shr   EAX,16            {  EAX [ 0 . 0 | 0 . H ]  }
          Add   BX,AX             {  EBX [ W+E+G | V+F+H ]  }
                                  {  M = W+E+G / N = V+F+H  }
                                  {  EBX [   M   |   N   ]  }

          Add   ESI,316
          LodSD                   {  EAX [ L . K | J . I ]  }
          Shl   EDX,8             {  EDX [ G . F | E . 0 ]  }
          Mov   DX,AX             {  EDX [ G . F | J . I ]  }
          Shr   DX,8              {  EDX [ G . F | 0 . J ]  }
          Add   BX,DX             {  EBX [   M   |  N+J  ]  }
          Rol   EBX,16            {  EBX [  N+J  |   M   ]  }
          Add   BX,DX             {  EBX [  N+J  |  M+J  ]  }
          Mov   DL,AL             {  EDX [ F . G | 0 . I ]  }
          Add   BX,DX             {  EBX [  N+J  | M+I+J ]  }
          Shr   EAX,8             {  EAX [ 0 . L | K . J ]  }
          Shr   AX,8              {  EAX [ 0 . L | 0 . K ]  }
          Add   BX,AX             {  EBX [  N+J  |M+I+J+K]  }
          Rol   EBX,16            {  EBX [M+I+J+K|  N+J  ]  }
          Add   BX,AX             {  EBX [M+I+J+K| N+J+K ]  }
          Shr   EAX,16            {  EAX [ 0 . 0 | 0 . L ]  }
          Add   BX,AX             {  EBX [M+J+K+L|N+J+K+L]  }
                                  {  P = M+I+J+K / Q = N+J+K+L  }
                                  {  EBX [   P   |   Q   ]  }

          Shr   EDX,8             {  EDX [ 0 . G | F . 0 ]  }
          Shr   DX,8              {  EDX [ 0 . G | 0 . F ]  }
          Ror   EDX,16            {  EDX [ 0 . F | 0 . G ]  }


          Shr   BX,3              {  EBX [   P   | Q / 8 ]  }
          Add   BX,DX             {  EBX [   P   |(Q/8)+G]  }
          Shr   BX,1              {  EBX [   P   |((Q/8)+G)/2]  }
                                  {  EBX [   P   |   Y   ]  }

          Cmp   BL,10             { If Y is greater than 10 we apply }
          JB    @@NoBIAS          { a negative BIAS on it. In high   }
          Sub   BL,2              { level it goes like this:         }
     @@NoBIAS:                    { If (Y > 10) then Y = Y-4         }

          Ror   EBX,16            {  EBX [   Y   |   P   ]  }
          Shr   BX,3              {  EBX [   Y   | P / 8 ]  }
          Shr   EDX,16            {  EDX [ 0 . 0 | 0 . F ]  }
          Add   BX,DX             {  EBX [   Y   |(P/8)+F]  }
          Shr   BX,1              {  EBX [   Y   |((Q/8)+F)/2]  }
                                  {  EBX [ 0 . Y | 0 . X ]  }

          Cmp   BL,10             { If X is greater than 10 we apply }
          JB    @@NoBIAS2         { a negative BIAS on it. In high   }
          Sub   BL,2              { level it goes like this:         }
     @@NoBIAS2:                   { If (X > 10) then X = X-4         }

          Shl   BX,8              {  EBX [ 0 . Y | X . 0 ]  }
          Shr   EBX,8             {  EBX [ 0 . 0 | Y . X ]  }

          Mov   Word PTR [EDI],BX {  Let's store the two pixels in memory  }
          Add   EDI,2             {  and increment EDI to point to the next
                                     two  }
          Sub   ESI,642           {  ESI is decremented to point to "C" }
          Dec   CX                {  CX is DECed - two point less to go! }
          JNZ   @@XLoop           {  If CX<>0 then goto @@XLoop }

          Add   EDI,2             {  When a line is complete EDI and ESI  }
          Add   ESI,2             {  must be INCed that way. If you have
                               problems understanding why draw a scheme:
                               I couldn't stand another ASCII drawing!!! 8D }
          Rol   ECX,16            {  We exchange the two words of ECX to  }
          Dec   CX                {  DEC the line counter  }
          JNZ   @@YLoop           {  If CX<>0 then goto @@YLoop }

          Call  VSync

          { Copies VS2 into video memory }
          Mov   ESI,Offset [VS2]
          Mov   EAX,ESI
          Mov   EDI,[_zero]
          Add   EDI,$A0000
          Mov   CX,16000
        @@RepLup:
          MovSD
          Dec   CX
          JNZ   @@RepLup

          { Copies VS2 into VS1 }
          Mov   ESI,EAX   { Offset VS2 }
          Mov   EDI,Offset [VS1]
          Mov   CX,16000

        @@RepLup2:
          MovSD
          Dec   CX
          JNZ   @@RepLup2

          Pop   EBX      {  Restore the regz before exiting  }
          Pop   ECX
          Pop   EDX
     end;

     until Port[$60]<$80; { A dirty equivalent of a "keypressed" }

     { Set mode 3h - Text 80x50x16 }
     Asm
        Mov   AX,3h
        Int   10h
     end;
end.
